/*
/* uncompress / gunzip file
/**/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "uudeview.h"
#include "uuerror.h"
#include "uuutil.h"

uulist *uncompress (uulist *data)
{
  char bef[255], *ptr;
  uulist *new;

  if (!(data->state & ST_DECODED))
    if (uudecode (data) != 1)
      return NULL;
  if (data->state & ST_UNCOMP)
    return data->branch;

  if ((ptr = strrchr (data->filename, '.')) == NULL) {
    uuerror = NOCOMP;
    return NULL;
  }
  if (strcmp (ptr, ".Z") == 0 || strcmp (ptr, ".tz") == 0 ||
      strcmp (ptr, ".z") == 0)
    strcpy (bef, "uncompress");
  else if (strcmp (ptr, ".gz" ) == 0 || strcmp (ptr, ".tgz") == 0 ||
           strcmp (ptr, ".taz") == 0)
    strcpy (bef, "gunzip");
  else {
    uuerror = NOCOMP;
    return NULL;
  }

  if ((new = (uulist *) malloc (sizeof (uulist))) == NULL) {
    uuerror = NOMEM;
    return NULL;
  }
  if ((new->filename = (char *) malloc (strlen(data->filename)+2)) == NULL) {
    free (new);
    uuerror = NOMEM;
    return NULL;
  }
  strcpy (new->filename, data->filename);

  if ((new->binfile = tempnam (NULL, "uu")) == NULL) {
    free (new->filename);
    free (new);
    uuerror = NOMEM;
    return NULL;
  }
  ptr = strrchr (new->filename, '.');

  if (strcmp (ptr, ".tz" ) == 0 || strcmp (ptr, ".tgz") == 0 ||
      strcmp (ptr, ".taz") == 0)
    strcpy (ptr, ".tar");
  else
    *ptr = '\0';
  
  strcat (bef, " -c ");
  strcat (bef, data->binfile);
  strcat (bef, " > ");
  strcat (bef, new->binfile);
  
  system (bef);

  data->state    = data->state | ST_UNCOMP;
  new->state     = ST_OK | ST_DECODED;
  new->mode      = data->mode;
  new->subfname  = _CopyLine (data->subfname, -1);
  new->tarblock  = -1;
  new->thisfile  = NULL;
  new->misparts  = NULL;
  new->branch    = NULL;
  new->NEXT      = NULL;

  if (exists (new->binfile) < 2) { /* File empty ? */
    killlist (new);
    uuerror = NOCOMP;
    new     = NULL;
  }

  data->branch   = new;

  return new;
}

