#include <malloc.h>
#include <stdio.h>
#include "uudeview.h"

/*
/* free some memory
/**/

void killfread (fileread *data)
{
  if (data != NULL) {
    free (data->subject);
    free (data->origin);
    free (data->filename);
    free (data->sfname);
    free (data);
  }
}

void killfile (uufile *data)
{
  if (data != NULL) {
    free      (data->filename);
    free      (data->subfname);
    killfread (data->data);
    killfile  (data->NEXT);

    free      (data);
  }
}

void killlist (uulist *data)
{
  if (data != NULL) {
    if (data->binfile != NULL && data->tarblock == -1)
      unlink (data->binfile);

    free     (data->filename);
    free     (data->binfile);
    free     (data->subfname);
    killfile (data->thisfile);
    free     (data->misparts);
    killlist (data->branch);
    killlist (data->NEXT);

    free     (data);
  }
}

void killext (extlist *data)
{
  if (data != NULL) {
    killext (data->NEXT);
    free    (data);
  }
}

void killif (infile *data)
{
  if (data != NULL) {
    killif (data->NEXT);
    free   (data);
  }
}

/*****************************************************************************
 + Frank Pilhofer                          frank@informatik.uni-frankfurt.de +
 +---------------------------------------------------------------------------+
 | Department of Computer Sciences * University of Frankfurt / Main, Germany |
 *****************************************************************************/

